<?php
/**
    Explorer : Plugin for GuppY 4.5 and 4.6
    under CeCILL v2 Free Software Agreement
    Initial version by Kimai: http://michaeldouchin.free.fr/demo/
    Rewrited, secured and enhanced by Hpsam : http://www.hpsam.info/
*/

header("Pragma: no-cache");
define("CHEMIN", "../../");
include(CHEMIN."inc/includes.inc");
include(CHEMIN."inc/hpage.inc");

// Find plugin name (in case of duplication)
$explorer_folder = explode('/', str_replace('\\', '/', dirname(__FILE__)));
$explorer_folder = $explorer_folder[count($explorer_folder) - 1];
$explorer_name   = ucfirst($explorer_folder);

include(CHEMIN . 'plugins/' . $explorer_folder . '/lang/' . $lng . '-exp-web.inc');
include(CHEMIN . DATAREP . 'plugins/' . $explorer_folder . '/configuration.inc');

/**
 * Sort a bi level array by one of his column
 *
 * @param array $array Array to sort
 * @param string $sortRow Index of the row use for the sort
 * @param string $sortType Sort direction SORT_DESC, SORT_ASC...
 * @return array The sorted array
 */
function exp_sortData($array, $sortRow, $sortType) {
    foreach ($array as $key => $row) {
        $tri[$key] = strtolower($row[$sortRow]);
    }
    if (is_array($tri)) {
        array_multisort($tri, $sortType, $array);
    }
    return $array;
}

/**
 * Function to display the file size in ko, Mo
 *
 * @param unknown_type $size
 * @return unknown
 */
function convertSize($size) {
    global $exp_web5;
    if ($size == 0)  return $exp_web5[0];
    $ko = 1024;        // kilo Bytes
    if ($size < $ko) return sprintf($exp_web5[1], $size);
    $mo = 1024 * $ko;  // Mega Bytes
    if ($size < $mo) return sprintf($exp_web5[2], $size / $ko, 2);
    $go = 1024 * $mo;  // Giga Bytes
    if ($size < $go) return sprintf($exp_web5[3], $size / $mo, 2);
    $to = 1024 * $go;  // Tera Bytes
    if ($size < $to) return sprintf($exp_web5[4], $size / $go, 2);
    return sprintf($exp_web5[5], $size / $to, 2);
}

$exp_titre = ($lng == $lang[1]) ? $exp_name[1] : $exp_name[0];
htable($exp_titre, "100%");

// VERIFICATIONS AND DATA

// check if members only and visitor is not a member
if ($exp_members && $userprefs[1] == "") {
    echo "<p align=\"center\">".$web342."</p><br />";
    echo "<p align=\"center\">[ <a href=\"".CHEMIN."user.php?lng=".$lng."\">".$web343."</a> ]</p><br />";
    btable();
    include(CHEMIN."inc/bpage.inc");
    die();
}

// exp_currentFolder is the folder wich has been selected by the user (by clicking the folder image = submit button of one form)
$exp_currentFolder = isset($_POST['exp_currentFolder']) ? strip_tags($_POST['exp_currentFolder']) : '';
$exp_currentFolderPath = empty($exp_currentFolder) ? $exp_root : $exp_root . $exp_currentFolder;

// check if the $exp_currentFolderPath is secure
if(strpos(realpath(CHEMIN . $exp_currentFolderPath), realpath(CHEMIN . $exp_root)) !== 0) {
    echo '<b>' . $exp_web1 . '</b>';
    btable();
    include(CHEMIN."inc/bpage.inc");
    die();
}

// Displays the top message
echo (($lng == $lang[1]) ? PathToImage($exp_message[1]) : PathToImage($exp_message[0])) . '<br />';

// CREATE AND DISPLAYS THE FOLDER TREE ABOVE THE SELECTED FOLDER (HOMEDIR)

echo '<fieldset><legend>' . $exp_web3 . '</legend>
';

// Root folder
echo '<form method="post" action="?lng=' . $lng . '" name="formulaire">
<input type="hidden" name="exp_currentFolder" value="" />
<input type="image" src="img/folder.gif" border="0" width="20px" id="exp_treeRoot" />
<label for="exp_treeRoot">&nbsp;&nbsp;' . $exp_web6 . '</label></form>
';

// Sub-folders
$exp_currentFolderPathParts = explode('/', $exp_currentFolderPath);
$exp_nbCurrentFolderPathParts = count($exp_currentFolderPathParts) -1;
$exp_nbRootParts = count(explode('/', $exp_root)) -1;

$exp_prevFolder = '';
$textedecalage = '\--';
for ($i = $exp_nbRootParts; $i < $exp_nbCurrentFolderPathParts; $i++) {
    echo '<form method="post" action="?lng=' . $lng . '" name="formulaire">
<input type="hidden" name="exp_currentFolder" value="' . $exp_prevFolder . $exp_currentFolderPathParts[$i] . '/" />
<span style="font-family: Courrier">' . $textedecalage . '</span>
<input type="image" src="img/folder.gif" border="0" width="20px" id="exp_tree' . $i . '" />
<label for="exp_tree' . $i . '">&nbsp;&nbsp;' . $exp_currentFolderPathParts[$i] . '</label>
</form>
';
    $textedecalage = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $textedecalage;
    $exp_prevFolder .= $exp_currentFolderPathParts[$i] . '/';
}

// displays current folder

echo '</fieldset>
';

// EXPLORE THE FOLDERS, FIND THE FILES AND PUT THEIR INFORMATIONS IN PHP TABLES

// Array of folder (0 => Address, 1 => Name)
$foldersArray = array();
$exp_fol = 0;
// Array of files (0=> Address, 1 => Name, 2 => Size, 3 => Counter, 4 => File icon)
$filesArray   = array();
$exp_fic = 0;

// Explore the folder
$dir = opendir(CHEMIN . $exp_currentFolderPath);
while (false !== ($file = readdir($dir))) {
    if (!preg_match('/^\.+\w?/', $file) && ($file != 'index.php')) {
        // If it is a folder, put the following info in a table
        if (is_dir(CHEMIN . $exp_currentFolderPath . $file)) {
            // Address of the folder
            $foldersArray[$exp_fol][0] = $exp_currentFolder . $file ;
            // Name of the folder
            $foldersArray[$exp_fol][1] = $file ;
            $exp_fol++;
        }
        // else it is a file, we put the following info in a table
        else {
            // address of the file
            $filesArray[$exp_fic][0] = $exp_currentFolder . $file;
            // name of the file
            $filesArray[$exp_fic][1] = $file;
            // size of the file;
            $filesArray[$exp_fic][2] = filesize(CHEMIN . $exp_currentFolderPath . $file);
            // counter value
            $exp_counterName = str_replace ('/', '_', $exp_currentFolderPath . $file . '.txt');
            if (file_exists(CHEMIN . 'data/plugins/' . $explorer_folder . '/counters/' . $exp_counterName)) {
                $filesArray[$exp_fic][3] = (int) trim(file_get_contents(CHEMIN . 'data/plugins/' . $explorer_folder
                                                                        . '/counters/' . $exp_counterName));
            } else {
                $filesArray[$exp_fic][3] = 0;
            }

            // find its extension and use it to give the file an icon
            $exp_fileType = substr($file, strrpos($file, '.') + 1);

            if ($exp_fileType == 'mp3' || $exp_fileType == 'ogg' || $exp_fileType == 'wma'
                    || $exp_fileType == 'wav' || $exp_fileType == 'mid') {
                $filesArray[$exp_fic][4] = 'im_audio.png';
            } elseif ($exp_fileType == 'avi' || $exp_fileType == 'wmv' || $exp_fileType == 'mpeg'
                    || $exp_fileType == 'mpg' || $exp_fileType == 'vob' || $exp_fileType == 'xvid'
                    || $exp_fileType == 'ra' || $exp_fileType == 'rm' || $exp_fileType == 'mov'
                    || $exp_fileType == 'mp+' || $exp_fileType == 'mpc') {
                $filesArray[$exp_fic][4] = 'im_video.png';
            } elseif ($exp_fileType == 'pdf' || $exp_fileType == 'ps') {
                $filesArray[$exp_fic][4] = 'im_pdf.png';
            } elseif ($exp_fileType == 'doc' || $exp_fileType == 'txt' || $exp_fileType == 'rtf'
                    || $exp_fileType == 'sxw' || $exp_fileType == 'sdw') {
                $filesArray[$exp_fic][4] = 'im_texte.png';
            } elseif ($exp_fileType == 'jpg' || $exp_fileType == 'gif' || $exp_fileType == 'png'
                    || $exp_fileType == 'bmp' || $exp_fileType == 'ico' || $exp_fileType == 'jp2'
                    || $exp_fileType == 'raw'|| $exp_fileType == 'tif') {
                $filesArray[$exp_fic][4]='im_image.png';
            } elseif ($exp_fileType == 'xls' || $exp_fileType == 'sxc' || $exp_fileType == 'pxl'
                    || $exp_fileType == 'sdc') {
                $filesArray[$exp_fic][4] = 'im_classeur.png';
            } elseif ($exp_fileType == 'tar' || $exp_fileType == 'zip' || $exp_fileType == 'gzip'
                    || $exp_fileType == '7z' || $exp_fileType == '7z' || $exp_fileType == 'bz2'
                    || $exp_fileType == 'gz') {
                $filesArray[$exp_fic][4]='im_zip.png';
            } elseif ($exp_fileType == 'htm' || $exp_fileType == 'html' || $exp_fileType == 'php'
                    || $exp_fileType == 'php3' || $exp_fileType == 'php5' || $exp_fileType == 'xml'
                    || $exp_fileType == 'css') {
                $filesArray[$exp_fic][4] = 'im_web.png';
            } else {
                $filesArray[$exp_fic][4] = 'im_reste.png';
            }

            $filesArray[$exp_fic][5] = filemtime(CHEMIN . $exp_currentFolderPath . $file);

            $exp_fic++;
        }
    }
}
closeDir($dir);

// DISPLAYS THE FOLDERS AND FILES OF THE HOMEDIR

$foldersArray = exp_sortData($foldersArray, 1, SORT_ASC);
$filesArray   = exp_sortData($filesArray,   1, SORT_ASC);

echo '<table id="explorerFolderTable" border="0" cellpadding="5" style="text-align:right">
';

// display the folders
$i = 0;
foreach($foldersArray as $folderArray) {
    echo '    <tr>
    <td colspan="3" style="text-align:left"><form method="post" action="?lng=' . $lng . '">
         <input type="hidden" name="exp_currentFolder" value="' . $folderArray[0] . '/" />
         <input type="image" src="img/folder.gif" alt="' . $folderArray[1] . '" width="20px" id="exp_folder' . $i . '" />
         <label for="exp_folder' . $i . '">&nbsp;&nbsp;' . $folderArray[1] . '</label>
         </form></td></tr>
';
    $i++;
}
echo '</table>
<script src="' . CHEMIN . 'plugins/' . $explorer_folder . '/sorttable.js"></script>
<style>#explorerFileTable .sortIcon {background: transparent url(\'img/updown.gif\') no-repeat 0 center; padding-left: 15px;}</style>
<table id="explorerFileTable" border="0" cellpadding="5" style="text-align:right" class="sortable">
<thead>
    <tr style="text-align:center; font-weight:bold;" class="quest">
        <td><span class="sortIcon">' . $exp_web7 . '</span></td>
        <td><span class="sortIcon">' . $exp_web8 . '</span></td>
        <td><span class="sortIcon">' . $exp_web9 . '</span></td>
        <td><span class="sortIcon">' . $exp_web11 . '</span></td>
    </tr>
</thead>
<tbody>
';
// display the sorted files
$exp_dateFormat = ($lng == $lang[1]) ? $exp_date[1] : $exp_date[0];
foreach($filesArray as $fileArray) {
    //link between file type and icone
    echo '    <tr>
    <td style="text-align:left">
    <a target="_blank" href="clic.php?url=' . $fileArray[0] . '">
        <img alt="' . $fileArray[4] . '" src="img/' . $fileArray[4] . '" border="0" width="20" />
        &nbsp;&nbsp;' . $fileArray[1] . '</a>
    </td>
    <td sorttable_customkey="' . $fileArray[2] . '">(<b>' . convertSize($fileArray[2]) . '</b>)</td>
    <td sorttable_customkey="' . $fileArray[5] . '">' . date($exp_dateFormat, $fileArray[5]) . '</td>
    <td>' . $fileArray[3] . '</td>
    </tr>
';
}
echo '</tbody></table>';
if (($serviz[32]=="on" && !empty($serviz[31]) && $serviz[31]==$userprefs[1])
    || ($serviz[32]=="on" && $drtuser['$explorer_folder']=="on")) {
    echo '<p align="right">
<a href="' . CHEMIN . 'admin/admin.php?lng=' . $lng . '&amp;pg=plugin&amp;plug=' . $explorer_folder . '/explorer">
<img src="' . CHEMIN . 'inc/img/general/edit.gif" border="0"  title="' . $web308 . '"></a></p>
';
}
btable();
include(CHEMIN . 'inc/bpage.inc');
?>
